<!--
[VERSION 1.0 - Nr of users per geofence]

[Purpose]
List number of users per geofence in the defined application

[Description]
Example of how the GpsGate API can be used to retrieve information from the platform and displayed on a website. This is written in HTML and PHP.

[How to use]
- Change the parameters in settings.php
- Upload the files to a webserver meeting the requirements listed below

[Requirements]
- Webserver (i.e. Nginx, Apache, IIS) with PHP & PHP-Curl support

-->

<?php
/* Reload the page automatically on set interval*/
$page = $_SERVER['PHP_SELF'];
$sec = "1000"; //Set to number of seconds between each page reload
?>
<html>
	<head>
		<meta http-equiv="refresh" content="<?php echo $sec?>;URL='<?php echo $page?>'">
		<title>DevEnv</title>
		<link href="stylesheet.css" rel="stylesheet"/>
		<!-- Font Awesome -->
		<link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0/css/all.min.css" rel="stylesheet"/>
		<!-- Google Fonts -->
		<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700&display=swap" rel="stylesheet"/>
		<!-- MDB -->
		<link href="https://cdnjs.cloudflare.com/ajax/libs/mdb-ui-kit/4.2.0/mdb.min.css" rel="stylesheet"/>
		<!-- MDB -->
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mdb-ui-kit/4.2.0/mdb.min.js"></script>
	</head>
	<body>
	<div class="container">
		<div class="accordion accordion-flush" id="accordionFlushList">
				<?php
					include "settings.php";
					include "functions.php";

					// Fetch all geofences in specified application
					$api_result = callAPI($serverurl."/applications/".$appID."/geofences",$api_token);
					$assocDataArray = array();

					for ($i = 0; $i < count($api_result); $i++)  {
						$assocDataArray[$api_result[$i]->id] = $api_result[$i]->name;
					}
					
					// Fetch all users for the found geofences
					$i = 1;
					foreach($assocDataArray as $key => $value) {
						$apiUser_result = callAPI($serverurl."/applications/".$appID."/geofences/".$key."/users",$api_token);
						$assocUserArray = array();
						for ($j = 0; $j < count($apiUser_result); $j++)  {
							$assocUserArray[$apiUser_result[$j]->id] = $apiUser_result[$j]->name;
						}
						
						?>
						<div class="accordion-item">
							<h2 class="accordion-header" id="flush-heading<?php echo $i;?>">
								<button
									class="accordion-button collapsed fs-6"
									type="button"
									data-mdb-toggle="collapse"
									data-mdb-target="#flush-collapse<?php echo $i;?>"
									aria-expanded="false"
									aria-controls="flush-collapse<?php echo $i;?>"
								>
								<?php echo $value." (".count($apiUser_result).")"; ?>
								</button>
							</h2>
							<div
								id="flush-collapse<?php echo $i;?>"
								class="accordion-collapse collapse"
								aria-labelledby="flush-heading<?php echo $i;?>"
								data-mdb-parent="#accordionFlushList"
							    >
							 <div class="accordion-body">
							 	<ul class="list-group list-group-horizontal">
							 	<?php
							 		$j = 1;
									foreach ($assocUserArray as $keyUser=>$valueUser) {									
										?>
											<li class="list-group-item fs-6"><?php echo $valueUser; ?></li>
										<?php
										if(fmod($j,10) == 0) {
											?>
												</ul>
												<ul class="list-group list-group-horizontal">
											<?php
										}
										$j += 1;
									}
								?>
								</ul>
							 </div>
							</div>
							<?php
						$totalUsers += count($apiUser_result);
						$totalGeofences += 1;
						$i += 1;
					}
					?>
				</div>
			<div class="container-md">
				<div class="row justify-content-center">
					<div class="col-4"><b>Nr. of geofences:</b> <?php echo $totalGeofences; ?></div>
					<div class="col-4"><b>Total nr. of devices:</b> <?php echo $totalUsers;?></div>
				</div>
			</div>
		</div>
	</div>
	</body>
</html>